var $4mxld$jsxpragmatic = require("jsx-pragmatic");
var $4mxld$zoid = require("zoid");

function $parcel$export(e, n, v, s) {
  Object.defineProperty(e, n, {get: v, set: s, enumerable: true, configurable: true});
}
function $parcel$interopDefault(a) {
  return a && a.__esModule ? a.default : a;
}

$parcel$export(module.exports, "Notabene", () => $fef5d623a19b12b5$export$2e2bcd8739ae039);


let $fef5d623a19b12b5$export$7f2c168e71c689ea;
(function($fef5d623a19b12b5$export$7f2c168e71c689ea) {
    $fef5d623a19b12b5$export$7f2c168e71c689ea["ALL"] = "ALL";
    $fef5d623a19b12b5$export$7f2c168e71c689ea["VASP_2_VASP_ONLY"] = "VASP_2_VASP_ONLY";
    $fef5d623a19b12b5$export$7f2c168e71c689ea["SELF_TRANSACTION_ONLY"] = "SELF_TRANSACTION_ONLY";
})($fef5d623a19b12b5$export$7f2c168e71c689ea || ($fef5d623a19b12b5$export$7f2c168e71c689ea = {}));
let $fef5d623a19b12b5$export$1a2fd016dc0a19e9;
(function($fef5d623a19b12b5$export$1a2fd016dc0a19e9) {
    $fef5d623a19b12b5$export$1a2fd016dc0a19e9["SIGNATURE"] = "SIGNATURE";
    $fef5d623a19b12b5$export$1a2fd016dc0a19e9["DECLARATION"] = "DECLARATION";
    $fef5d623a19b12b5$export$1a2fd016dc0a19e9["SIGNATURE_OR_DECLARATION"] = "SIGNATURE_OR_DECLARATION";
})($fef5d623a19b12b5$export$1a2fd016dc0a19e9 || ($fef5d623a19b12b5$export$1a2fd016dc0a19e9 = {}));
class $fef5d623a19b12b5$export$2e2bcd8739ae039 {
    constructor(config){
        this.config = config;
        this.config.nonCustodialDeclarationType = config.nonCustodialDeclarationType || $fef5d623a19b12b5$export$1a2fd016dc0a19e9.SIGNATURE;
        this.config.transactionTypeAllowed = config.transactionTypeAllowed || $fef5d623a19b12b5$export$7f2c168e71c689ea.ALL;
        this.widgetRendered = false;
        this.popupRendered = false;
    }
    async renderWidget() {
        if (this.widgetRendered) {
            console.error('Notabene: Widget already rendered, please destroy it first');
            return;
        }
        this.widget = await this.buildWidget();
        this.popup = await this.buildPopup();
        this.widget.updateProps({
            transaction: this.tx
        });
        this.popup.updateProps({
            transaction: this.tx
        });
        this.popup.hide();
        await this.widget.render(this.config.container);
        await this.renderPopup();
    }
    async renderPopup() {
        if (!this.popup) return;
        if (!this.popupRendered) {
            await this.popup.render(this.config.container);
            this.popupRendered = true;
        }
    }
    async destroyWidget() {
        await $4mxld$zoid.destroy();
        this.widgetRendered = false;
        this.popupRendered = false;
    }
    setTransaction(tx) {
        const validProperties = [
            'transactionAsset',
            'transactionAmount',
            'beneficiaryAccountNumber',
            'beneficiaryAccountNumber',
            'originatorVASPdid',
            'originatorDid',
            'transactionBlockchainInfo',
            'beneficiaryVASPname',
            'beneficiaryVASPdid',
            'beneficiaryName',
            'beneficiaryGeographicAddress',
            'beneficiaryNationalIdentification',
            'beneficiaryDateAndPlaceOfBirth',
            'beneficiaryDid',
            'isNonCustodial',
            'originatorEqualsBeneficiary',
            'beneficiaryProof',
            'isValid',
            'errors', 
        ];
        if (tx) Object.keys(tx).forEach((key)=>{
            if (!validProperties.includes(key)) throw new Error(`Notabene: Invalid transaction property ${key}`);
        });
        this.tx = tx;
        if (this.widgetRendered) {
            this.widget.updateProps({
                transaction: tx
            });
            this.popup.updateProps({
                transaction: tx
            });
        }
    }
    getWidgetUrl() {
        const url = new URL(this.config.widget);
        url.hash = `authToken=${this.config.authToken}`;
        return url.toString();
    }
    getAdditionalInfoUrl() {
        const url = new URL(this.config.widget);
        url.search = 'popup=true';
        url.hash = `authToken=${this.config.authToken}`;
        return url.toString();
    }
    handleError(err) {
        this.error = err;
        if (this.widget && this.popup) {
            this.widget.updateProps({
                error: err
            });
            this.popup.updateProps({
                error: err
            });
        }
        if (!err || !this.config.onError) return;
        this.config.onError(err);
    }
    buildWidget() {
        if (!this.config.authToken) {
            console.error('Notabene: authToken is required');
            return;
        }
        const builtWidget = ($parcel$interopDefault($4mxld$zoid)).create({
            tag: 'widget',
            url: this.getWidgetUrl(),
            dimensions: {
                width: '100%',
                height: '280px'
            },
            props: {
                vaspDID: {
                    type: 'string',
                    required: true
                },
                transaction: {
                    type: 'object',
                    required: false
                },
                onRequireAdditionalInformation: {
                    type: 'function',
                    required: true
                },
                onValidStateChange: {
                    type: 'function',
                    required: true
                },
                error: {
                    type: 'object',
                    required: false
                },
                onError: {
                    type: 'function',
                    required: true
                },
                storeTransaction: {
                    type: 'function',
                    required: true
                },
                theme: {
                    type: 'object',
                    required: false
                },
                dictionary: {
                    type: 'object',
                    required: false
                },
                transactionTypeAllowed: {
                    type: 'string',
                    required: false
                },
                nonCustodialDeclarationType: {
                    type: 'string',
                    required: false
                },
                beneficiaryDetails: {
                    type: 'array',
                    required: false
                }
            }
        })({
            vaspDID: this.config.vaspDID,
            transaction: {},
            theme: this.config.theme,
            dictionary: this.config.dictionary,
            transactionTypeAllowed: this.config.transactionTypeAllowed,
            nonCustodialDeclarationType: this.config.nonCustodialDeclarationType,
            beneficiaryDetails: this.config.beneficiaryDetails,
            onRequireAdditionalInformation: ()=>{
                this.popup.updateProps({
                    popupOpen: true
                });
                this.popup.show();
            },
            onValidStateChange: (isValid)=>{
                this.config.onValidStateChange(isValid);
            },
            error: this.error,
            onError: (err)=>{
                this.handleError(err);
                console.debug('Notabene: Error handler called');
            },
            storeTransaction: (tx)=>{
                this.setTransaction(tx);
            }
        });
        builtWidget.event.on(($parcel$interopDefault($4mxld$zoid)).EVENT.RENDERED, (err)=>{
            this.widgetRendered = true;
        });
        return builtWidget;
    }
    buildPopup() {
        if (!this.config.authToken) {
            console.error('Notabene: authToken is required');
            return;
        }
        const builtPopup = ($parcel$interopDefault($4mxld$zoid)).create({
            tag: 'popup',
            url: this.getAdditionalInfoUrl(),
            children: ()=>{
                return {
                    Transaction: this.tx
                };
            },
            dimensions: {
                width: '100%',
                height: '100%'
            },
            props: {
                vaspDID: {
                    type: 'string',
                    required: true
                },
                transaction: {
                    type: 'object',
                    required: false
                },
                storeTransaction: {
                    type: 'function',
                    required: true
                },
                close: {
                    type: 'function'
                },
                theme: {
                    type: 'object',
                    required: false
                },
                dictionary: {
                    type: 'object',
                    required: false
                },
                transactionTypeAllowed: {
                    type: 'string',
                    required: false
                },
                nonCustodialDeclarationType: {
                    type: 'string',
                    required: false
                },
                popupOpen: {
                    type: 'boolean',
                    required: true
                },
                setPopupOpen: {
                    type: 'function',
                    required: true
                },
                error: {
                    type: 'object',
                    required: false
                },
                onError: {
                    type: 'function',
                    required: true
                },
                beneficiaryDetails: {
                    type: 'array',
                    required: false
                }
            },
            containerTemplate: ({ uid: uid , doc: doc , frame: frame , prerenderFrame: prerenderFrame  })=>{
                return $4mxld$jsxpragmatic.node('div', {
                    id: uid,
                    class: 'nb-container'
                }, $4mxld$jsxpragmatic.node('style', null, `
            #${uid}.container {
                border: 5px solid red;
            }
            .nb-overlay {
              position: fixed;
              width: 100vw;
              height: 100vh;
              top: 0;
              left: 0;
              display: flex;
              align-items: center;
              justify-content: center;
              background-color: rgba(0,0,0,0.5);
            }
            .nb-popup {
              max-width: 608px;
              width: 100%;
              height: 100%;
            }
            .nb-preloader {
              display: none;
            }
          `), $4mxld$jsxpragmatic.node('div', {
                    class: 'nb-overlay'
                }, $4mxld$jsxpragmatic.node('node', {
                    el: frame,
                    class: 'nb-popup'
                }), $4mxld$jsxpragmatic.node('node', {
                    el: prerenderFrame,
                    class: 'nb-preloader'
                }))).render($4mxld$jsxpragmatic.dom({
                    doc: doc
                }));
            }
        })({
            vaspDID: this.config.vaspDID,
            transaction: this.tx,
            beneficiaryDetails: this.config.beneficiaryDetails,
            storeTransaction: (tx)=>{
                this.setTransaction(tx);
                console.debug('Notabene: Transaction stored');
            },
            close: ()=>{
                this.popup.close();
                console.debug('Notabene: Popup closing');
            },
            setPopupOpen: (isOpen)=>{
                this.popup.updateProps({
                    popupOpen: isOpen
                });
            },
            error: this.error,
            onError: (err)=>{
                this.handleError(err);
                console.debug('Notabene: Error handler called');
            },
            popupOpen: false,
            theme: this.config.theme,
            dictionary: this.config.dictionary,
            transactionTypeAllowed: this.config.transactionTypeAllowed,
            nonCustodialDeclarationType: this.config.nonCustodialDeclarationType
        });
        builtPopup.event.on(($parcel$interopDefault($4mxld$zoid)).EVENT.RENDERED, (err)=>{
            this.popupRendered = true;
        });
        return builtPopup;
    }
}
if (window) window.Notabene = $fef5d623a19b12b5$export$2e2bcd8739ae039;




